\
\ This file allows reading and writing the EEPROM of the PIC.
\
\ $ProjectVersion: sc-rewrite.4 $
\

\ ee@ is similar to @ for the EEPROM

:: ee@ ( addr -- b )
   eeadr !
   eepgd bit-clr
   rd bit-set
   eedata @
;

\ eeprom-write expects the address in EEADR and the data in EEDATA

: eeprom-write ( -- )
    eepgd bit-clr
    wren bit-set
    disable-interrupts
    55 eecon2 !
    aa eecon2 !
    wr bit-set
    enable-interrupts
    wren bit-clr
;
    
\ wait-for-eeprom waits for the end of a write operation

code wait-for-eeprom ( -- )
    eecon1 adjust-bank forth> drop
label: wait-for-eeprom0
    wr btfsc
    wait-for-eeprom0 goto
    restore-bank
    return
end-code

\ ee! is similar to ! for the EEPROM

: ee! ( b addr -- ) wait-for-eeprom eeadr ! eedata ! eeprom-write ;
